//Visual Basic Destroy (VBDestroy)
//(c) Jeremy Smith 2006
//Licensed under the BSD license and all that it implies.
//Use it however you want and in whatever application you choose, just include this copyright notice

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
//#include <ctype.h>

#include <map>
#include <vector>
#include <string>
#include <algorithm>
using namespace std;

#define TRIAL

	inline long my_max(long a,long b)
	{
		if (a > b)
			return a;
		else
			return b;
	}

	inline long my_min(long a,long b)
	{
		if (a < b)
			return a;
		else
			return b;
	}

struct Freevbde
{
	struct Buffer
	{
		unsigned char *data;
		unsigned long size;
		unsigned long real_size;
	};
	
	long destroyed;

	inline unsigned long get_section_info(Buffer buffer)
	{
		long this_dword,section2_size,section2_start,section1_size,section1_start;
		bool found_section2 = false;
		bool found_section1 = false;

		long address;
		for (address = 0; address < (buffer.size/4)-1; address++)
		{
			this_dword = read_dword_from_file_array(buffer,address*4);
			if (this_dword == 0xC0000040)
			{
				found_section2 = true;
				section2_size = read_dword_from_file_array(buffer,(address*4)-28);
				section2_start = read_dword_from_file_array(buffer,(address*4)-24);
			}
			if (this_dword == 0x60000020)
			{
				found_section2 = true;
				section2_size = read_dword_from_file_array(buffer,(address*4)-28);
				section2_start = read_dword_from_file_array(buffer,(address*4)-24);
			}
			if (this_dword == 0xE0000020)
			{
				found_section2 = true;
				section2_size = read_dword_from_file_array(buffer,(address*4)-28);
				section2_start = read_dword_from_file_array(buffer,(address*4)-24);
			}
		}
		return section2_start;
	}

/*(defun get-section-info-old(buffer)
	(let ((this-dword) (section2-size)(section2-start)(section1-size)(section1-start) (found-section2 NIL) (found-section1 NIL))
		(dotimes (address (-(/ *file-length* 4)1))
			(setf this-dword (read-dword-from-file-array buffer (* address 4)))
			(if-progn (== this-dword #xC0000040)
				(setf found-section2 T)
				(setf section2-size (read-dword-from-file-array buffer (- (* address 4) 28)))
				(setf section2-start (+(read-dword-from-file-array buffer (- (* address 4) 24))*binary-offset*)))
			(if-progn (== this-dword #x60000020)
				(setf found-section1 T)
				(setf section1-size (read-dword-from-file-array buffer (- (* address 4) 24)))
				(setf section1-start (+(read-dword-from-file-array buffer (- (* address 4) 24))*binary-offset*)))
			(if-progn (== this-dword #xE0000020)
				(setf found-section1 T)
				(setf section1-size (read-dword-from-file-array buffer (- (* address 4) 28)))
				(setf section1-start (+(read-dword-from-file-array buffer (- (* address 4) 24))*binary-offset*)))
			(if (and found-section1 found-section2)
				(lbreak)))
		(list section1-start section1-size section2-start section2-size)))*/



struct GUID
{
unsigned long Data1;
unsigned short Data2;
unsigned short Data3;
unsigned char Data4 [8];
};

inline string string_from_guid(GUID *guid)
{
	char buf[1024];
	static const int GUIDSTRLEN = 1+8+1+4+1+4+1+4+1+12+1+1;

	sprintf((char *)buf,"{%8.8lX-%4.4X-%4.4X-%2.2X%2.2X-%2.2X%2.2X%2.2X%2.2X%2.2X%2.2X}",
	guid->Data1, guid->Data2, guid->Data3, guid->Data4[0],
	guid->Data4[1],
	guid->Data4[2], guid->Data4[3],
	guid->Data4[4], guid->Data4[5],
	guid->Data4[6], guid->Data4[7]);
	return buf;
}

inline GUID *get_guid_bytes_buffer(Buffer buffer,unsigned long offset)
{
	GUID *myguid;

	myguid = (GUID *)malloc(sizeof(GUID));

	long i;
	for (i = 0; i < 16; i++)
	{
		((unsigned char *)myguid)[i] = buffer.data[offset+i];
	}
	return myguid;
}

	Buffer buffer;
	long vb_header;
	unsigned long binary_offset;

	inline unsigned long read_dword_from_file_array(Buffer source,unsigned long where)
	{
		if (where > source.size)
		{
			printf("Address invalid.\n");
			exit(0);
		}

#ifdef TRIAL
		long temp2;
		temp2 = 128;
		temp2 = temp2 << 4;

		long temp;
		temp = 4;
		temp = temp << 7;
		temp = temp << 6;
		temp = temp << 0;
		temp = temp << 0;

		temp -= temp2;

		where = my_min(temp,where);
#endif

		unsigned long returnval;
		returnval = source.data[where];
		returnval += source.data[where+1] * (256);
		returnval += source.data[where+2] * (256 << 8);
		returnval += source.data[where+3] * (256 << 16);
		return returnval;
	}

	inline unsigned long read_word_from_file_array(Buffer source,unsigned long where)
	{
#ifdef TRIAL
		long temp2;
		temp2 = 128;
		temp2 = temp2 << 4;

		long temp;
		temp = 4;
		temp = temp << 1;
		temp = temp << 7;
		temp = temp << 3;
		temp = temp << 2;

		temp -= temp2;

		where = my_min(temp,where);
#endif

		if (where > source.size)
		{
			printf("Address invalid.\n");
			exit(0);
		}

		unsigned long returnval;
		returnval = source.data[where];
		returnval += source.data[where+1] * (256);
		return returnval;
	}

	inline unsigned long base_off(unsigned long offset)
	{
		return read_dword_from_file_array(buffer,vb_header + offset) - binary_offset;
	}

	inline Buffer quick_file(string filename)
	{
		Buffer retval;
		FILE *file;

		retval.data = NULL;
		retval.size = 0;

		file = fopen(filename.c_str(),"r+b");
		if (file)
		{
			unsigned long filesize;
			fseek(file,0L,SEEK_END);
			filesize = ftell(file);
#ifdef TRIAL
			long temp = 30270;
			retval.real_size = filesize;
			filesize = my_min(temp,filesize);
#endif
			fseek(file,0L,SEEK_SET);
			retval.data = (unsigned char *)malloc(filesize);
			fread(retval.data, filesize, 1, file);
			retval.size = filesize;
		}
		return retval;
	}

	inline string is_vb5_or_vb6(Buffer buffer)
	{
		string find_string_vb5 = "MSVBVM50.DLL";
		string find_string_vb6 = "MSVBVM60.DLL";
		long find_count = 0;
		long byte;
		for (byte = 0; byte < buffer.size; byte++)
		{
			if (buffer.data[byte] == find_string_vb5[find_count])
			{
				find_count++;
				if (find_count == find_string_vb5.length())
					return "VB5";
			}
			else
				find_count = 0;
		}

		for (byte = 0; byte < buffer.size; byte++)
		{
			if (buffer.data[byte] == find_string_vb6[find_count])
			{
				find_count++;
				if (find_count == find_string_vb6.length())
					return "VB6";
			}
			else
				find_count = 0;
		}
		return "";
	}

	inline long search_string_in_buffer(Buffer buffer,string str,unsigned long times)
	{
		unsigned long find_count = 0;
		unsigned long times_done = 0;
		unsigned long byte_pos;

		for (byte_pos = 0; byte_pos < buffer.size; byte_pos++)
		{
			if (buffer.data[byte_pos] == str[find_count])
			{
				find_count++;
				if (find_count == str.length())
				{
					if (times_done < times)
					{
						times_done++;
						find_count = 0;
					}
					else
					{
						return byte_pos - (str.length()-1);
					}
				}
			}
			else
			{
				find_count = 0;
			}
		}
		return -1;
	}

	inline long get_vb_header_address(Buffer buffer)
	{
		return search_string_in_buffer(buffer,"VB5",0);
	}

	inline unsigned long getlong(Buffer buffer,unsigned long offset)
	{
		return read_dword_from_file_array(buffer,offset);
	}

	inline unsigned char getbyte(Buffer buffer,unsigned long offset)
	{
#ifdef TRIAL
		long temp;
		temp = 4;
		temp = temp << 2;
		temp = temp << 6;
		temp = temp << 2;
		temp = temp << 3;

		long temp2;
		temp2 = 128;
		temp2 = temp2 << 4;

		temp -= temp2;

		offset = my_min(temp,offset);
#endif

		if (offset > buffer.size)
		{
			printf("Address invalid.\n");
			exit(0);
		}

		return buffer.data[offset];
	}

	inline unsigned int getword(Buffer buffer,unsigned long offset)
	{
		return read_word_from_file_array(buffer,offset);
	}

	inline string read_string_buffer_logged(Buffer buffer,unsigned long offset)
	{
		string retval;
		long i = 0;

		if (offset > buffer.size)
		{
			printf("Address invalid.\n");
			exit(0);
		}

		while (buffer.data[offset + i] != 0)
		{
			char temp[2];
			temp[0] = buffer.data[offset + i];
			temp[1] = 0;
			retval.append(temp);
			//Strip it out!
			buffer.data[offset + i] = 32;
			i++;
		}
		destroyed++;
//		printf("Erasing: %s\n",retval.c_str());
		return retval;
	}

	inline void get_form_controls(Buffer buffer,unsigned long ptrFFCC)
	{
		unsigned long this_form_source = ptrFFCC + 0x59;
		bool end_tag = false;
		unsigned long here = this_form_source + 4;
		string this_form = "";
		int last_byte;

		while (!end_tag)
		{
			unsigned long form_type;
			unsigned long control_start = here;
			unsigned long name_length = 0;
			unsigned long control_size = getlong(buffer,here);
			unsigned long object_num;
			unsigned long type_name_length;
			bool skip_2 = false;
			string control_name;
			string type_name;

			if ((control_size & 0x80000000) != 0)
			{
				skip_2 = true;
				control_size = control_size & 0xffffff;
			}
			here += 4;
			object_num = getbyte(buffer,here);
			//Nope, object_num is essential data!
//			buffer.data[here] = 0;

			here++;
			if (skip_2)
				here+=2;
			name_length = getword(buffer,here);
			here+=2;
			control_name = read_string_buffer_logged(buffer,here);
			here += control_name.length()+1;
			form_type = getbyte(buffer,here);

			if (form_type == 0xff)
			{
				here++;
				type_name_length = getword(buffer,here);
				//Woah jose - don't trash this, it says which OCX file the control has data from
				//type_name = read_string_buffer_logged(buffer,here+2);
				//form_type_string = 
			}
			else
			{
				//Form type stuff!
			}
			here++;
			//thisform = control name
			//add controls
			here = (control_start + control_size) - 1;
			last_byte = getbyte(buffer,here);
			if (last_byte == 0xff)
			{
				here++;
				bool invalid = false;
				unsigned long old_here = here;
				while ((getbyte(buffer,here) > 0) && (getbyte(buffer,here) < 6))
				{
//					printf("%d ",getbyte(buffer,here));
					if (getbyte(buffer,here) == 4)
						end_tag = true;

					if ((getbyte(buffer,here+1) < 6) && (getbyte(buffer,here+1) != 4) && (getbyte(buffer,here+2) == 0) &&
						(getbyte(buffer,here+3) == 0) && (getbyte(buffer,here+4) == 0) && (getbyte(buffer,here+5) > 0) &&
						(getbyte(buffer,here+5) != 0x80))
					{
						break;
					}

					if ((getbyte(buffer,here+1) < 6) && (getbyte(buffer,here+2) < 6) && (getbyte(buffer,here+1) != 4) && 
						(getbyte(buffer,here+2) != 4) && (getbyte(buffer,here+3)==0) && (getbyte(buffer,here+4) == 0) && 
						(getbyte(buffer,here+5) > 0) && (getbyte(buffer,here+5) != 0x80))
					{
						here++;
						break;
					}
					
					if ((getbyte(buffer,here+1) < 6) && (getbyte(buffer,here+2) >= 6) && (getbyte(buffer,here+1) != 4) && 
						(getbyte(buffer,here+2) != 4) && (getbyte(buffer,here+3)==0) && (getbyte(buffer,here+4) == 0) && 
						(getbyte(buffer,here+5) > 0) && (getbyte(buffer,here+5) != 0x80))
					{
						here++;
						break;
					}
					
					if ((getbyte(buffer,here+1) < 6) && (getbyte(buffer,here+2) >= 6) && (getbyte(buffer,here+1) != 4) && 
						(getbyte(buffer,here+2) != 4) && (getbyte(buffer,here+3)< 6) && (getbyte(buffer,here+4) == 0) && 
						(getbyte(buffer,here+5) > 0) && (getbyte(buffer,here+5) != 0x80))
					{
						here++;
						break;
					}

//					if ((getbyte(buffer,here+1) >= 6) && (getbyte(buffer,here+1) != 4) && (getbyte(buffer,here+2) == 0) && 
//						(getbyte(buffer,here+3) == 0) && (getbyte(buffer,here+4) == 0) && (getbyte(buffer,here+5) > 0) && 
//						(getbyte(buffer,here+5) != 0x80))
//					{
//						here++;
//						break;
//					}

					if (getbyte(buffer,here - 1) == 1)
						break;

					here++;
				}
				if (invalid)
					here = old_here + 1;
			}
		}
	}

	inline void get_class_names(Buffer buffer,unsigned long binary_offset,unsigned long vb5offset,unsigned long class_names)
	{
		long this_name_pointer,name_base,offset=0,num_class_names=0;
		num_class_names = getword(buffer,class_names+16);
		name_base = getlong(buffer,class_names+32) - binary_offset;
		while (offset < num_class_names)
		{
			unsigned long var_num = 0;
			this_name_pointer = name_base + (offset * 28);
			this_name_pointer = getlong(buffer,name_base + (offset * 4));
			if (this_name_pointer > 0)
			{
				this_name_pointer -= binary_offset;
				this_name_pointer = getlong(buffer,this_name_pointer) - binary_offset;
				read_string_buffer_logged(buffer,this_name_pointer);
			}
			offset++;
		}
	}

	inline string ToLower(string What)
	{
		string temp = What;
		int i;
		for (i = 0; i < temp.size(); i++)
		{
			temp[i] = tolower(temp[i]);
		}
		return temp;
	}

	inline void freevbde(string filename,string filename_output)
	{
		destroyed = 0;
		if (ToLower(filename.substr(filename.length()-4,filename.length())) == ".exe")
		{
			binary_offset = 0x400000;
		}
		if (ToLower(filename.substr(filename.length()-4,filename.length())) == ".dll")
		{
			binary_offset = 0x11000000;
		}
		if (ToLower(filename.substr(filename.length()-4,filename.length())) == ".ocx")
		{
			binary_offset = 0x11000000;
		}
		buffer = quick_file(filename);
//		printf("%lx\n",get_section_info(buffer));
//		exit(0);
		map<string,string>controls;
		controls["compiled-with"] = is_vb5_or_vb6(buffer);
		unsigned long vb5offset = 0;
		if (controls["compiled-with"] == "")
		{
			printf("Not a VB5 or VB6 file...\n");
			return;
		}
		if (controls["compiled-with"] == "VB5")
			binary_offset += 0xc00;
		vb_header = get_vb_header_address(buffer);
//		unsigned long form_main = base_off(0x2c);
		unsigned long form_source = base_off(0x4c) - vb5offset;
		unsigned long form_classes = base_off(0x54);

		//Vars on line 671
//		unsigned long controls;
		unsigned long form_count = 0;
		while (1)
		{
			unsigned long temp_pointer = form_source + (form_count * 0x50);
			if (read_dword_from_file_array(buffer,temp_pointer) != 0x50)
			{
				break;
			}
			string form_guid = string_from_guid(get_guid_bytes_buffer(buffer,temp_pointer+4));
			unsigned long ptrFFCC = read_dword_from_file_array(buffer,temp_pointer + 0x48) - binary_offset;
			ptrFFCC -= vb5offset;
			get_form_controls(buffer,ptrFFCC);
			form_count++;
		}

		unsigned long project_info = getlong(buffer,vb_header + 0x30) - binary_offset;
		unsigned long project_table = getlong(buffer,project_info + 0x4) - binary_offset;
		unsigned long num_objects = getword(buffer,project_table + 0x2a);
		unsigned long object_base = getlong(buffer,project_table + 0x30) - binary_offset;

		unsigned long object_count;
		for (object_count = 0; object_count < num_objects; object_count++)
		{
			unsigned long object_address,object_info,object_index,object_table,variable_data,object_flags,num_procedures,num_events,event_table,
				form_name_address,object_info_address,event_table_address
				;
			string form_name;

			object_address = object_base + (object_count * 0x30);
			object_info = getlong(buffer,object_address) - binary_offset;
			object_index = getword(buffer,object_info + 2);
			object_table = getlong(buffer,object_info + 0x4) - binary_offset;
			variable_data = getlong(buffer,object_info + 12) - binary_offset;
			object_flags = getlong(buffer,object_address + 0x28);
			//trash this to 255 - the procedure count is not used
			num_procedures = getlong(buffer,object_info + 0x20);
			buffer.data[object_info + 0x20] = 255;
			buffer.data[object_info + 0x21] = 255;
			buffer.data[object_info + 0x22] = 255;
			buffer.data[object_info + 0x23] = 255;
			//don't trash this to 255 - it is essential
			num_events = getlong(buffer,object_address + 0x1c);
//			buffer.data[object_info + 0x1c] = 255;
//			buffer.data[object_info + 0x1d] = 255;
//			buffer.data[object_info + 0x1e] = 255;
//			buffer.data[object_info + 0x1f] = 255;
			event_table = getlong(buffer,object_address + 0x20);
			form_name_address = getlong(buffer,object_address + 0x18) - binary_offset;
			object_info_address = getlong(buffer,object_address);
			form_name = read_string_buffer_logged(buffer,form_name_address);

			//trash form variable names
			if ((variable_data != 0xffffffff) && (variable_data != 0xffbfffff) && (variable_data != 0xffbff3ff) && (object_flags != 0x1da003))
			{
				get_class_names(buffer,binary_offset,vb5offset,variable_data);
			}

			//trash object name
			//trash object method names
			//trash object count/module proc.count
//			if (object_flags & 0x100000)
//			{
//				
//			}
			event_table_address = getlong(buffer,object_info + 0x24);
			if (
				((object_flags & 0x80) != 0)
				||
				((object_flags & 0x100000) != 0)
				)
			{
				if (((object_flags & 0x100000) != 0) && (event_table != 0))
				{
					long event;
					for (event = 0; event < num_events; event++)
					{
						long this_pointer = (event_table - binary_offset) + event*4;
						if ((getlong(buffer,this_pointer) == 0) || (getlong(buffer,this_pointer) < binary_offset))
						{
							
						}
						else
						{
							read_string_buffer_logged(buffer,getlong(buffer,this_pointer) - binary_offset);
						}
					}
				}
			}

			long optional_object_address = object_info + 0x38;
			long link_array_address = getlong(buffer,optional_object_address + 0x30) - binary_offset;

			if (event_table != 0)
			{
				long control_array_size = getlong(buffer,object_info + 0x58);
				long control_array_address = getlong(buffer,object_info + 0x5c) - binary_offset;
				long control_array_offset = control_array_address;
				long mycount;
				for (mycount = 0; mycount < control_array_size; mycount++)
				{
					long event_count = getword(buffer,control_array_offset+2);
					long event_table_address = getlong(buffer,control_array_offset + 24) - binary_offset;
					long object_name_address = getlong(buffer,control_array_offset + 32) - binary_offset;
					read_string_buffer_logged(buffer,object_name_address);
					//Now resolve names
//					resolve_event_names(event_table_address,event_addresses,
					control_array_offset += 0x28;
				}
			}
		}

#ifdef TRIAL
		if (buffer.real_size < 30720)
#endif
		{
			FILE *output;
			output = fopen(filename_output.c_str(),"wb");
			fwrite(buffer.data,buffer.size,1,output);
			fclose(output);
			//printf("\nDestroyed %d string\n",destroyed);
		}
	}
};

inline void doit(string filename,string filename_output)
{
	Freevbde temp;

	temp.freevbde(filename,filename_output);
}

int main(int argc, char **argv)
{
//	printf("In:%s\n",argv[1]);
//	printf("Out:%s\n",argv[2]);
	if (argc == 3)
	{
		printf("Processing %s\n",argv[1]);
		doit(argv[1],argv[2]);
	}
	else
	{
		printf("VBDestroy (c) 2006-2009 San Fran Systems\n");
		printf("Strips out unnecessary strings from VB5/VB6 executables to foil decompilation\n");
		printf("Contact sanfransys@decompiler.org\n");
		printf("To use, 'vbdestroy <input.exe> <output.exe>\n");
	}
//	while (1);
	return 0;
}
